<?php

namespace Teknisa\CADFIS\Factories;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Teknisa\CADFIS\Services;
use Teknisa\CADFIS\Strategies;
use Teknisa\CADFIS\Services\MarcaService;
use Teknisa\CADFIS\Services\MarcProdService;
use Teknisa\CADFIS\Services\ProdFornService;
use Teknisa\CADFIS\Services\CompradorService;
use Teknisa\CADFIS\Services\ProdCompService;
use Teknisa\CADFIS\Services\RegiaoService;
use Teknisa\CADFIS\Services\GerenteService;
use Teknisa\CADFIS\Services\FormPgtoService;
use Teknisa\CADFIS\Services\FornecedorService;

class ServicesFactory 
{
    protected $crudService;
    
    public function __construct(EntityManager $entityManager, $crudService, Connection $connection, Environment $environment)
    {
        $this->entityManager = $entityManager;
        $this->crudService = $crudService;
        $this->connection = $connection;
        $this->environment = $environment;
    }
    
    public function getMarcaService()
	{
	    return new MarcaService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getMarcProdService()
	{
	    return new MarcProdService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getProdFornService()
	{
	    return new ProdFornService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getCompradorService()
	{
	    return new CompradorService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getProdCompService()
	{
	    return new ProdCompService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getRegiaoService()
	{
	    return new RegiaoService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getGerenteService()
	{
	    return new GerenteService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getFormPgtoService()
	{
	    return new FormPgtoService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
	
	public function getFornecedorService()
	{
	    return new FornecedorService($this->entityManager, $this->crudService, $this->connection, $this->environment);
	}
}